//
// File name AsagiriWrapper.cpp
// Implemetation of CAsagiriWrapper class.
// Copyright (C) 2003-2004 Comona Co., Ltd.
//
// IN̍ۂAsagiri.dll̃[hEA[he֐AhX擾sAnh
// Vbp񋟂NXłB
// TvAvP[VłSampApp.h"_EXPLICIT_LOAD_"`̃RgOƂɂ
// Ďgp\ƂȂ܂B
// Asagiri.exe̓CXg[̍ہAAsagiri.dll𓯈fBNgɊi[܂B
// WXgɂAsagiri.exẽpX".exe"ȍ~폜΂̂܂DLL̃[hɗpł܂B
// AvP[V쐬ꍇ̂܂܂pƂz肵č쐬ꂽNXłB
//
#include "StdAfx.h"
#include "AsagiriWrapper.h"

// ֐ԍ`
#define FUNCNO_INITIALIZE					1
#define FUNCNO_UNINITIALIZE					2
#define FUNCNO_STARTENUM					3
#define FUNCNO_RESETENUM					6
#define FUNCNO_ENDENUM						7
#define FUNCNO_REMOVEITEM					28
#define FUNCNO_GETLASTCOMRESULT				29
#define FUNCNO_DELETEBINARY					32
// ASCIIUNICODEŎۂɎgp֐Ⴄ
#ifndef _UNICODE	// ASCII
#define FUNCNO_ENUMNEXT						4
#define FUNCNO_GETTEXT						8
#define FUNCNO_GETBITMAP					10
#define FUNCNO_GETBINARY					12
#define FUNCNO_GETIMAGEFILEINBINARY			14
#define FUNCNO_GETFILENAME					16
#define FUNCNO_ADDPOPUP						18
#define FUNCNO_ADDTEXT						20
#define FUNCNO_ADDBITMAP					22
#define FUNCNO_ADDBINARY					24
#define FUNCNO_ADDFILE						26
#define FUNCNO_DELETESTRING					30
#else	// UNICODE
#define FUNCNO_ENUMNEXT						5
#define FUNCNO_GETTEXT						9
#define FUNCNO_GETBITMAP					11
#define FUNCNO_GETBINARY					13
#define FUNCNO_GETIMAGEFILEINBINARY			15
#define FUNCNO_GETFILENAME					17
#define FUNCNO_ADDPOPUP						19
#define FUNCNO_ADDTEXT						21
#define FUNCNO_ADDBITMAP					23
#define FUNCNO_ADDBINARY					25
#define FUNCNO_ADDFILE						27
#define FUNCNO_DELETESTRING					31
#endif

// RXgN^
CAsagiriWrapper::CAsagiriWrapper()
{
	// DLLnh
	m_hDLL = NULL;
	// nh
	m_hHandle = NULL;
	// AsagiriInitialize()p
	m_lpfnInitialize = NULL;
	// AsagiriUninitialize()p
	m_lpfnUninitialize = NULL;
	// AsagiriStartEnum()p
	m_lpfnStartEnum = NULL;
	// AsagiriEnumNext()p
	m_lpfnEnumNext = NULL;
	// AsagiriResetEnum()p
	m_lpfnResetEnum = NULL;
	// AsagiriEndEnum()p
	m_lpfnEndEnum = NULL;
	// AsagiriGetText()p
	m_lpfnGetText = NULL;
	// AsagiriGetBitmap()p
	m_lpfnGetBitmap = NULL;
	// AsagiriGetBinary()p
	m_lpfnGetBinary = NULL;
	// AsagiriGetImageFileInBinary()p
	m_lpfnImageFileInBinary = NULL;
	// AsagiriGetFileName()p
	m_lpfnGetFileName = NULL;
	// AsagiriAddPopup()p
	m_lpfnAddPopup = NULL;
	// AsagiriAddText()p
	m_lpfnAddText = NULL;
	// AsagiriAddBitmap()p
	m_lpfnAddBitmap = NULL;
	// AsagiriAddBinary()p
	m_lpfnAddBinary = NULL;
	// AsagiriAddFile()p
	m_lpfnAddFile = NULL;
	// AsagiriRemoveItem()p
	m_lpfnRemoveItem = NULL;
	// AsagiriGetLastComResult()p
	m_lpfnGetLastComResult = NULL;
	// AsagiriDeleteString()p
	m_lpfnDeleteString = NULL;
	// AsagiriDeleteBinary()p
	m_lpfnDeleteBinary = NULL;
}

// fXgN^
CAsagiriWrapper::~CAsagiriWrapper()
{
	if (m_hHandle != NULL) {
		m_lpfnUninitialize(m_hHandle);	// nhJ
	}
	if (m_hDLL != NULL) {
		::FreeLibrary(m_hDLL);	// DLLA[h
	}
}

// 쐬֐
BOOL CAsagiriWrapper::Create()
{
	if (m_hHandle != NULL) {
		return TRUE;
	}
	BOOL fCreate = LoadLibrary();
	if (fCreate != FALSE) {	// ֐|C^̃Zbgs܂
		// AsagiriInitialize()p
		m_lpfnInitialize = (ASAGIRIIINITIALIZEFUNC) ::GetProcAddress(m_hDLL, MAKEINTRESOURCEA(FUNCNO_INITIALIZE));
		// AsagiriUninitialize()p
		m_lpfnUninitialize = (ASAGIRIIUNINITIALIZEFUNC) ::GetProcAddress(m_hDLL, MAKEINTRESOURCEA(FUNCNO_UNINITIALIZE));
		// AsagiriStartEnum()p
		m_lpfnStartEnum = (ASAGIRISTARTENUMFUNC) ::GetProcAddress(m_hDLL, MAKEINTRESOURCEA(FUNCNO_STARTENUM));
		// AsagiriEnumNext()p
		m_lpfnEnumNext = (ASAGIRIENUMNEXTFUNC) ::GetProcAddress(m_hDLL, MAKEINTRESOURCEA(FUNCNO_ENUMNEXT));
		// AsagiriResetEnum()p
		m_lpfnResetEnum = (ASAGIRIENDENUMFUNC) ::GetProcAddress(m_hDLL, MAKEINTRESOURCEA(FUNCNO_RESETENUM));
		// AsagiriEndEnum()p
		m_lpfnEndEnum = (ASAGIRIENDENUMFUNC) ::GetProcAddress(m_hDLL, MAKEINTRESOURCEA(FUNCNO_ENDENUM));
		// AsagiriGetText()p
		m_lpfnGetText = (ASAGIRIGETTEXTFUNC) ::GetProcAddress(m_hDLL, MAKEINTRESOURCEA(FUNCNO_GETTEXT));
		// AsagiriGetBitmap()p
		m_lpfnGetBitmap = (ASAGIRIGETBITMAPFUNC) ::GetProcAddress(m_hDLL, MAKEINTRESOURCEA(FUNCNO_GETBITMAP));
		// AsagiriGetBinary()p
		m_lpfnGetBinary = (ASAGIRIGETBINARYFUNC) ::GetProcAddress(m_hDLL, MAKEINTRESOURCEA(FUNCNO_GETBINARY));
		// AsagiriGetImageFileInBinary()p
		m_lpfnImageFileInBinary = (ASAGIRIGETBINARYFUNC) ::GetProcAddress(m_hDLL, MAKEINTRESOURCEA(FUNCNO_GETIMAGEFILEINBINARY));
		// AsagiriGetFileName()p
		m_lpfnGetFileName = (ASAGIRIGETFILENAMEFUNC) ::GetProcAddress(m_hDLL, MAKEINTRESOURCEA(FUNCNO_GETFILENAME));
		// AsagiriAddPopup()p
		m_lpfnAddPopup = (ASAGIRIADDPOPUPFUNC) ::GetProcAddress(m_hDLL, MAKEINTRESOURCEA(FUNCNO_ADDPOPUP));
		// AsagiriAddText()p
		m_lpfnAddText = (ASAGIRIADDTEXTFUNC) ::GetProcAddress(m_hDLL, MAKEINTRESOURCEA(FUNCNO_ADDTEXT));
		// AsagiriAddBitmap()p
		m_lpfnAddBitmap = (ASAGIRIADDBITMAPFUNC) ::GetProcAddress(m_hDLL, MAKEINTRESOURCEA(FUNCNO_ADDBITMAP));
		// AsagiriAddBinary()p
		m_lpfnAddBinary = (ASAGIRIADDBINARYFUNC) ::GetProcAddress(m_hDLL, MAKEINTRESOURCEA(FUNCNO_ADDBINARY));
		// AsagiriAddFile()p
		m_lpfnAddFile = (ASAGIRIADDTEXTFUNC) ::GetProcAddress(m_hDLL, MAKEINTRESOURCEA(FUNCNO_ADDFILE));
		// AsagiriRemoveItem()p
		m_lpfnRemoveItem = (ASAGIRIREMOVEITEMFUNC) ::GetProcAddress(m_hDLL, MAKEINTRESOURCEA(FUNCNO_REMOVEITEM));
		// AsagiriGetLastComResult()p
		m_lpfnGetLastComResult = (ASAGIRIGETLASTCOMRESULTFUNC) ::GetProcAddress(m_hDLL, MAKEINTRESOURCEA(FUNCNO_GETLASTCOMRESULT));
		// AsagiriDeleteString()p
		m_lpfnDeleteString = (ASAGIRIDELETESTRINGFUNC) ::GetProcAddress(m_hDLL, MAKEINTRESOURCEA(FUNCNO_DELETESTRING));
		// AsagiriDeleteBinary()p
		m_lpfnDeleteBinary = (ASAGIRIDELETEBINARYFUNC) ::GetProcAddress(m_hDLL, MAKEINTRESOURCEA(FUNCNO_DELETEBINARY));
		// nh擾܂
		m_hHandle = m_lpfnInitialize();
	}

	return (m_hHandle != NULL) ? TRUE : FALSE;
}

// Cu𖾎IɃ[h
BOOL CAsagiriWrapper::LoadLibrary()
{
	BOOL fRet = FALSE;
	HKEY hKey = NULL;
	LONG lRet;
	DWORD dwType, dwSize, dwRet;
	char szPath[MAX_PATH + 1];

	// Asagiri.exẽpX擾
	lRet = ::RegOpenKeyExA(HKEY_CURRENT_USER, "SOFTWARE\\Comona\\Asagiri\\location", 0, KEY_QUERY_VALUE, &hKey);
	if (lRet == ERROR_SUCCESS) {
		dwType = REG_SZ;
		dwRet = 0;
		dwSize = MAX_PATH * sizeof(char);
		lRet = ::RegQueryValueExA(hKey, "exepath", NULL, &dwType, (LPBYTE) szPath, &dwSize);
		if (lRet == ERROR_SUCCESS) {
			szPath[dwSize / sizeof(char)] = NULL;	// Ô߂...
			fRet = TRUE;
		}
		::RegCloseKey(hKey);
	}

	// DLL[h܂
	if (fRet != FALSE) {
		LPSTR lpsz = ::strrchr(szPath, '.');	// ".exe"ȍ~폜
		if (lpsz != NULL) {
			*lpsz = NULL;
			m_hDLL = ::LoadLibraryA(szPath);	// DLL̃[h
			if (m_hDLL == NULL) {
				fRet = FALSE;	// [hs
			}
		}
	}

	return fRet;
}
