//
// File name AsagiriWrapper.h
// Definition of CAsagiriWrapper class.
// Copyright (C) 2003-2004 Comona Co., Ltd.
//
// IN̍ۂAsagiri.dll̃[hEA[he֐AhX擾sAnh
// Vbp񋟂NXłB
// TvAvP[VłSampApp.h"_EXPLICIT_LOAD_"`̃RgOƂɂ
// Ďgp\ƂȂ܂B
// Asagiri.exe̓CXg[̍ہAAsagiri.dll𓯈fBNgɊi[܂B
// WXgɂAsagiri.exẽpX".exe"ȍ~폜΂̂܂DLL̃[hɗpł܂B
// AvP[V쐬ꍇ̂܂܂pƂz肵č쐬ꂽNXłB
//
#if !defined(_ASAGIRI_SDK_SAMPLE_APPLICATION_ASAGIRIWRAPPER__INCLUDED_)
#define _ASAGIRI_SDK_SAMPLE_APPLICATION_ASAGIRIWRAPPER__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//
// ֐^̒`
// AsagiriInitialize()p
typedef HANDLE (WINAPI *ASAGIRIIINITIALIZEFUNC)();
// AsagiriUninitialize()p
typedef void (WINAPI *ASAGIRIIUNINITIALIZEFUNC)(HANDLE);
// AsagiriStartEnum()p
typedef HANDLE (WINAPI *ASAGIRISTARTENUMFUNC)(HANDLE, short, short);
// AsagiriEnumNext()p
typedef short (WINAPI *ASAGIRIENUMNEXTFUNC)(HANDLE, HANDLE, LPTSTR*, short*, short*);
// AsagiriResetEnum(), AsagiriEndEnum()p
typedef BOOL (WINAPI *ASAGIRIENDENUMFUNC)(HANDLE, HANDLE);
// AsagiriGetText()p
typedef BOOL (WINAPI *ASAGIRIGETTEXTFUNC)(HANDLE, short, LPTSTR*, LPTSTR*);
// AsagiriGetBitmap()p
typedef BOOL (WINAPI *ASAGIRIGETBITMAPFUNC)(HANDLE, short, HBITMAP*, LPTSTR*);
// AsagiriGetBinary(), AsagiriGetImageFileInBinary()p
typedef BOOL (WINAPI *ASAGIRIGETBINARYFUNC)(HANDLE, short, LPBYTE*, LPDWORD, LPTSTR*);
// AsagiriGetFileName()p
typedef BOOL (WINAPI *ASAGIRIGETFILENAMEFUNC)(HANDLE, short, LPTSTR*);
// AsagiriAddPopup()p
typedef BOOL (WINAPI *ASAGIRIADDPOPUPFUNC)(HANDLE, short, LPCTSTR);
// AsagiriAddText(), AsagiriAddFile()p
typedef BOOL (WINAPI *ASAGIRIADDTEXTFUNC)(HANDLE, short, LPCTSTR, LPCTSTR);
// AsagiriAddBitmap()p
typedef BOOL (WINAPI *ASAGIRIADDBITMAPFUNC)(HANDLE, short, LPCTSTR, HBITMAP);
// AsagiriAddBinary()p
typedef BOOL (WINAPI *ASAGIRIADDBINARYFUNC)(HANDLE, short, LPCTSTR, const BYTE*, DWORD);
// AsagiriRemoveItem()p
typedef BOOL (WINAPI *ASAGIRIREMOVEITEMFUNC)(HANDLE, short);
// AsagiriGetLastComResult()p
typedef HRESULT (WINAPI *ASAGIRIGETLASTCOMRESULTFUNC)(HANDLE);
// AsagiriDeleteString()p
typedef void (WINAPI *ASAGIRIDELETESTRINGFUNC)(HANDLE, LPTSTR);
// AsagiriDeleteBinary()p
typedef void (WINAPI *ASAGIRIDELETEBINARYFUNC)(HANDLE, LPBYTE);

// nĥ߂̃bp[NX
// MFCł̂p̏ꍇ
// class CAsagiriWrapper : public CObject
// ǂ܂
class CAsagiriWrapper
{
public:
	// RXgN^
	CAsagiriWrapper();
	// fXgN^
	virtual ~CAsagiriWrapper();

public:
	// 쐬֐
	BOOL Create();

public:	// CC֐`
	//
	// AsagiriStartEnum()p
	HANDLE StartEnum(short nParentID, short nType) { return m_lpfnStartEnum(m_hHandle, nParentID, nType); }
	//
	// AsagiriEnumNext()p
	short EnumNext(HANDLE hEnum, LPTSTR* lplpszTitle, short* lpnType, short* lpnTemp = NULL)
	{	return m_lpfnEnumNext(m_hHandle, hEnum, lplpszTitle, lpnType, lpnTemp);	}
	//
	// AsagiriResetEnum()p
	BOOL ResetEnum(HANDLE hEnum) { return m_lpfnResetEnum(m_hHandle, hEnum); }
	//
	// AsagiriEndEnum()p
	BOOL EndEnum(HANDLE hEnum) { return m_lpfnEndEnum(m_hHandle, hEnum); }
	//
	// AsagiriGetText()p
	BOOL GetText(short nID, LPTSTR* lplpszValue, LPTSTR* lplpszPathNam = NULL)
	{	return m_lpfnGetText(m_hHandle, nID, lplpszValue, lplpszPathNam);	}
	//
	// AsagiriGetBitmap()p
	BOOL GetBitmap(short nID, HBITMAP* phBitmap, LPTSTR* lplpszPathName = NULL)
	{	return m_lpfnGetBitmap(m_hHandle, nID, phBitmap, lplpszPathName);	}
	//
	// AsagiriGetBinary()p
	BOOL GetBinary(short nID, LPBYTE* lplpBytes, LPDWORD lpdwSize, LPTSTR* lplpszPathName = NULL)
	{	return m_lpfnGetBinary(m_hHandle, nID, lplpBytes, lpdwSize, lplpszPathName);	}
	//
	// AsagiriGetImageFileInBinary()p
	BOOL GetImageFileInBinary(short nID, LPBYTE* lplpBytes, LPDWORD lpdwSize, LPTSTR* lplpszPathName = NULL)
	{	return m_lpfnImageFileInBinary(m_hHandle, nID, lplpBytes, lpdwSize, lplpszPathName);	}
	//
	// AsagiriGetFileName()p
	BOOL GetFileName(short nID, LPTSTR* lplpszPathName)
	{	return m_lpfnGetFileName(m_hHandle, nID, lplpszPathName);	}
	//
	// AsagiriAddPopup()p
	BOOL AddPopup(short nParentID, LPCTSTR lpszTitle) { return m_lpfnAddPopup(m_hHandle, nParentID, lpszTitle); }
	//
	// AsagiriAddText()p
	BOOL AddText(short nParentID, LPCTSTR lpszTitle, LPCTSTR lpszText)
	{	return m_lpfnAddText(m_hHandle, nParentID, lpszTitle, lpszText);	}
	//
	// AsagiriAddBitmap()p
	BOOL AddBitmap(short nParentID, LPCTSTR lpszTitle, HBITMAP hBitmap)
	{	return m_lpfnAddBitmap(m_hHandle, nParentID, lpszTitle, hBitmap);	}
	//
	// AsagiriAddBinary()p
	BOOL AddBinary(short nParentID, LPCTSTR lpszTitle, const BYTE* lpByte, DWORD dwSize)
	{	return m_lpfnAddBinary(m_hHandle, nParentID, lpszTitle, lpByte, dwSize);	}
	//
	// AsagiriAddFile()p
	BOOL AddFile(short nParentID, LPCTSTR lpszTitle, LPCTSTR lpszPathName)
	{	return m_lpfnAddFile(m_hHandle, nParentID, lpszTitle, lpszPathName);	}
	//
	// AsagiriRemoveItem()p
	BOOL RemoveItem(short nID) { return m_lpfnRemoveItem(m_hHandle, nID);	}
	//
	// AsagiriGetLastComResult()p
	HRESULT GetLastComResult() { return m_lpfnGetLastComResult(m_hHandle); }
	//
	// AsagiriDeleteString()p
	void DeleteString(LPTSTR lpszString) { m_lpfnDeleteString(m_hHandle, lpszString); }
	//
	// AsagiriDeleteBinary()p
	void DeleteBinary(LPBYTE lpBin) { m_lpfnDeleteBinary(m_hHandle, lpBin); }

private:
	// Cu𖾎IɃ[h
	BOOL LoadLibrary();

private:
	// DLLnh
	HMODULE m_hDLL;
	// nh
	HANDLE m_hHandle;
	// AsagiriInitialize()p
	ASAGIRIIINITIALIZEFUNC m_lpfnInitialize;
	// AsagiriUninitialize()p
	ASAGIRIIUNINITIALIZEFUNC m_lpfnUninitialize;
	// AsagiriStartEnum()p
	ASAGIRISTARTENUMFUNC m_lpfnStartEnum;
	// AsagiriEnumNext()p
	ASAGIRIENUMNEXTFUNC m_lpfnEnumNext;
	// AsagiriResetEnum()p
	ASAGIRIENDENUMFUNC m_lpfnResetEnum;
	// AsagiriEndEnum()p
	ASAGIRIENDENUMFUNC m_lpfnEndEnum;
	// AsagiriGetText()p
	ASAGIRIGETTEXTFUNC m_lpfnGetText;
	// AsagiriGetBitmap()p
	ASAGIRIGETBITMAPFUNC m_lpfnGetBitmap;
	// AsagiriGetBinary()p
	ASAGIRIGETBINARYFUNC m_lpfnGetBinary;
	// AsagiriGetImageFileInBinary()p
	ASAGIRIGETBINARYFUNC m_lpfnImageFileInBinary;
	// AsagiriGetFileName()p
	ASAGIRIGETFILENAMEFUNC m_lpfnGetFileName;
	// AsagiriAddPopup()p
	ASAGIRIADDPOPUPFUNC m_lpfnAddPopup;
	// AsagiriAddText()p
	ASAGIRIADDTEXTFUNC m_lpfnAddText;
	// AsagiriAddBitmap()p
	ASAGIRIADDBITMAPFUNC m_lpfnAddBitmap;
	// AsagiriAddBinary()p
	ASAGIRIADDBINARYFUNC m_lpfnAddBinary;
	// AsagiriAddFile()p
	ASAGIRIADDTEXTFUNC m_lpfnAddFile;
	// AsagiriRemoveItem()p
	ASAGIRIREMOVEITEMFUNC m_lpfnRemoveItem;
	// AsagiriGetLastComResult()p
	ASAGIRIGETLASTCOMRESULTFUNC m_lpfnGetLastComResult;
	// AsagiriDeleteString()p
	ASAGIRIDELETESTRINGFUNC m_lpfnDeleteString;
	// AsagiriDeleteBinary()p
	ASAGIRIDELETEBINARYFUNC m_lpfnDeleteBinary;
};

#endif // !defined(_ASAGIRI_SDK_SAMPLE_APPLICATION_ASAGIRIWRAPPER__INCLUDED_)
