// SampAppDlg.cpp : t@C
// Copyright (C) 2003-2004 Comona Co., Ltd.
//

#include "stdafx.h"
#include "SampApp.h"
#include "SampAppDlg.h"
#include "NameDialog.h"

#ifdef _EXPLICIT_LOAD_
#include "AsagiriWrapper.h"
#endif

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// oCit@C16i_v₷邽߂̒`
#define BINARY_TEMPLATE	_T("%07X0 %02X %02X %02X %02X %02X %02X %02X %02X | %02X %02X %02X %02X %02X %02X %02X %02X | %c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c\r\n")
#define BINARY_SAMPLE	_T("00000000 00 00 00 00 00 00 00 00 | 00 00 00 00 00 00 00 00 | ................\r\n")
#define LEAD_FOR8		_T("00000000 00 00 00 00 00 00 00 00 | ")
#define LEAD_FORLAST	_T("00000000 00 00 00 00 00 00 00 00 | 00 00 00 00 00 00 00 00 | ")

// CSampAppDlg _CAO

// WRXgN^
#ifndef _EXPLICIT_LOAD_
CSampAppDlg::CSampAppDlg(HANDLE hAsagiri) : CDialog(CSampAppDlg::IDD)
#else
CSampAppDlg::CSampAppDlg(CAsagiriWrapper* pAsagiri) : CDialog(CSampAppDlg::IDD)
#endif
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
#ifndef _EXPLICIT_LOAD_
	m_hAsagiri = hAsagiri;
#else
	m_pAsagiri = pAsagiri;
#endif
	m_hBmp = NULL;
	m_nPopupSDK = 0;
}

// fXgN^
CSampAppDlg::~CSampAppDlg()
{
	if (m_hBmp != NULL) {
		::DeleteObject((HGDIOBJ) m_hBmp);
	}
}

// DDX/DDV T|[g
void CSampAppDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSampAppDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSampAppDlg, CDialog)
	//{{AFX_MSG_MAP(CSampAppDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_ADDPOPUPBUTTON, OnBnClickedAddpopupbutton)
	ON_BN_CLICKED(IDC_ALLBUTTON, OnBnClickedAllbutton)
	ON_BN_CLICKED(IDC_BINARYBUTTON, OnBnClickedBinarybutton)
	ON_BN_CLICKED(IDC_BROWSEBUTTON, OnBnClickedBrowsebutton)
	ON_BN_CLICKED(IDC_CLIPIMAGEBUTTON, OnBnClickedClipimagebutton)
	ON_BN_CLICKED(IDC_CLIPTEXTBUTTON, OnBnClickedCliptextbutton)
	ON_BN_CLICKED(IDC_CONTENTSUPBUTTON, OnBnClickedContentsupbutton)
	ON_BN_CLICKED(IDC_FILENAMEBUTTON, OnBnClickedFilenamebutton)
	ON_BN_CLICKED(IDC_IMAGEBUTTON, OnBnClickedImagebutton)
	ON_BN_CLICKED(IDC_IMAGEUPBUTTON, OnBnClickedImageupbutton)
	ON_BN_CLICKED(IDC_TEXTBUTTON, OnBnClickedTextbutton)
	ON_BN_CLICKED(IDC_TEXTUPBUTTON, OnBnClickedTextupbutton)
	//}}AFX_MSG_MAP
	ON_COMMAND_RANGE(ASAITEMID_MIN, ASAITEMID_MAX, OnAsaItemCommand)	// ̃j[I
END_MESSAGE_MAP()


// CSampAppDlg bZ[W nh

// _CAȌ(WM_INITDIALOG)
BOOL CSampAppDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[VXe j[ɒǉ܂B
	// IDM_ABOUTBOX ́AVXe R}h͈͓̔ɂȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL) {
		CString strAboutMenu;
		// C[WpGÂ
		strAboutMenu.LoadString(IDS_CLIPBBOARDIMAGE);
		if (!strAboutMenu.IsEmpty()) {
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_CLIPBOARDIMAGE, strAboutMenu);
		}
		// AoEgǉ
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty()) {
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B
	m_menuEngine.SetCommandTarget(this);	// j[̃^[Qbg̃_CAOɐݒ
#ifndef _EXPLICIT_LOAD_
	m_menuEngine.SetAsagiriHandle(m_hAsagiri);
#else
	m_menuEngine.SetAsagiriObject(m_pAsagiri);
#endif
	// ŏɂ̃TvAvp̃|bvAbv쐬
	CString str;
	str.LoadString(IDS_POPUPSDK);
#ifndef _EXPLICIT_LOAD_
	m_nPopupSDK = ::AsagiriAddPopup(m_hAsagiri, m_nPopupSDK, str);
#else
	m_nPopupSDK = m_pAsagiri->AddPopup(m_nPopupSDK, str);
#endif
	
	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

// VXeR}h(WM_SYSCOMMAND)
void CSampAppDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF1) == IDM_ABOUTBOX) {
		CAboutDlg dlgAbout;	// AoEg_CAO
		dlgAbout.DoModal();
	}
	else if ((nID & 0xFFF1) == IDM_CLIPBOARDIMAGE) {
		// _CAO{bNXɗpӂꂽC[W̃GÂłG\tgłmF
		if (m_hBmp != NULL) {
			if (OpenClipboard() != FALSE) {
				// Nbv{[h̒gւ
				::EmptyClipboard();
				// Nbv{[hɃRs[
				HANDLE hGlb = ::CopyImage((HANDLE) m_hBmp, IMAGE_BITMAP, 0, 0, LR_COPYRETURNORG);
				::SetClipboardData(CF_BITMAP, hGlb);
				// Nbv{[h
				::CloseClipboard();
			}
		}
		else {
			AfxMessageBox(IDS_NOIMAGE);
		}
	}
	else {
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B
void CSampAppDlg::OnPaint() 
{
	if (IsIconic()) {
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else {
		CDialog::OnPaint();
	}
}

//[UŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CSampAppDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

//[U|bvAbvǉ{^܂B
void CSampAppDlg::OnBnClickedAddpopupbutton()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	CString str;
	if (m_nPopupSDK < 1) {
		str.LoadString(IDS_POPUPSDK);
		m_nPopupSDK = 0;
	}
	else {
		CNameDialog dlg;
		if (dlg.DoModal() == IDOK) {
			str = dlg.m_szName;
		}
	}
	if (str.IsEmpty() == FALSE) {
#ifndef _EXPLICIT_LOAD_
		short nID = ::AsagiriAddPopup(m_hAsagiri, m_nPopupSDK, str);
#else
		short nID = m_pAsagiri->AddPopup(m_nPopupSDK, str);
#endif
		if (nID > -1) {
			if (m_nPopupSDK == 0) {
				m_nPopupSDK = nID;
			}
		}
	}
}

//[USă{^܂B
void CSampAppDlg::OnBnClickedAllbutton()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	if (m_menuEngine.ShowPopupMenu(ASAITEMTYPE_ALL, GetDlgItem(IDC_ALLBUTTON)) == FALSE) {
		::AfxMessageBox(IDS_NOCORRESPDATA);
	}
}

//[UoCi{^܂B
void CSampAppDlg::OnBnClickedBinarybutton()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	if (m_menuEngine.ShowPopupMenu(ASAITEMTYPE_BINARYALL, GetDlgItem(IDC_BINARYBUTTON)) == FALSE) {
		::AfxMessageBox(IDS_NOCORRESPDATA);
	}
}

//[UQƃ{^܂B
void CSampAppDlg::OnBnClickedBrowsebutton()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	CString strPathName;
	GetDlgItem(IDC_FILEEDIT)->GetWindowText(strPathName);
	CFileDialog dlg(TRUE, 0, strPathName);
	if (dlg.DoModal() == IDOK) {
		GetDlgItem(IDC_FILEEDIT)->SetWindowText(dlg.GetPathName());
	}
}

//[UNbv{[hC[W{^܂B
void CSampAppDlg::OnBnClickedClipimagebutton()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	if (OpenClipboard() != FALSE) {
		HANDLE h = ::GetClipboardData(CF_BITMAP);
		if (h != NULL) {
			if (m_hBmp != NULL) {
				::DeleteObject((HGDIOBJ) m_hBmp);
			}
			m_hBmp = (HBITMAP) ::CopyImage(h, IMAGE_BITMAP, 0, 0, LR_COPYRETURNORG);
			::GlobalUnlock((HGLOBAL) h);
			((CStatic*) GetDlgItem(IDC_IMAGESTATIC))->SetBitmap(m_hBmp);
		}
		else {
			::AfxMessageBox(IDS_CLIPBOARDNOIMAGE);
		}
		::CloseClipboard();
	}
	else {
		::AfxMessageBox(IDS_CLIPBOARDFAILED);
	}
}

//[UNbv{[heLXg{^܂B
void CSampAppDlg::OnBnClickedCliptextbutton()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	if (OpenClipboard() != FALSE) {
		HANDLE h = ::GetClipboardData(CF_TEXT);
		if (h != NULL) {
			LPSTR lpsz = static_cast<LPSTR>(::GlobalLock((HGLOBAL) h));
#ifndef _UNICODE
			GetDlgItem(IDC_TEXTEDIT)->SetWindowText(lpsz);
#else
			CStringA str = lpsz;
			BSTR pStr = str.AllocSysString();
			GetDlgItem(IDC_TEXTEDIT)->SetWindowText(pStr);
			::SysFreeString(pStr);
#endif
			::GlobalUnlock((HGLOBAL) h);
		}
		else {
			::AfxMessageBox(IDS_CLIPBOARDNOTEXT);
		}
		::CloseClipboard();
	}
	else {
		::AfxMessageBox(IDS_CLIPBOARDFAILED);
	}
}

//[Ut@Cei[{^܂B
void CSampAppDlg::OnBnClickedContentsupbutton()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	if (m_nPopupSDK < 1) {
		m_nPopupSDK = 0;
		::AfxMessageBox(IDS_CREATEPOPUPSDKFIRST);
		return;
	}

	CString strPathName;
	GetDlgItem(IDC_FILEEDIT)->GetWindowText(strPathName);
	DWORD dwAttr = ::GetFileAttributes(strPathName);
	// Ȃ܂̓fBNg
	if ((dwAttr == 0xFFFFFFFF) || (dwAttr & FILE_ATTRIBUTE_DIRECTORY)) {
		::AfxMessageBox(IDS_PATHNOTFOUND);
		GotoDlgCtrl(GetDlgItem(IDC_FILEEDIT));
		return;
	}

	CNameDialog dlg;
	if (dlg.DoModal() == IDOK) {
		CFile file;
		CFileException e;
		if (file.Open(strPathName, CFile::modeRead, &e) != FALSE) {
			DWORD dwLen = (DWORD) file.GetLength();
			LPBYTE lpBinary = new BYTE[dwLen];
			if (lpBinary != NULL) {
				file.Read(lpBinary, (UINT) dwLen);
#ifndef _EXPLICIT_LOAD_
				short nID = ::AsagiriAddBinary(m_hAsagiri, m_nPopupSDK, dlg.m_szName, lpBinary, dwLen);
#else
				short nID = m_pAsagiri->AddBinary(m_nPopupSDK, dlg.m_szName, lpBinary, dwLen);
#endif
				if (nID < 0) {
					::AfxMessageBox(IDS_FAILEDITEMADD);
				}
				delete[] lpBinary;
			}
			file.Close();
		}
	}
}

//[Ut@Ci[{^܂B
void CSampAppDlg::OnBnClickedFilenamebutton()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	if (m_nPopupSDK < 1) {
		m_nPopupSDK = 0;
		::AfxMessageBox(IDS_CREATEPOPUPSDKFIRST);
		return;
	}

	CString strPathName;
	GetDlgItem(IDC_FILEEDIT)->GetWindowText(strPathName);
	DWORD dwAttr = ::GetFileAttributes(strPathName);
	// Ȃ܂̓fBNg
	if ((dwAttr == 0xFFFFFFFF) || (dwAttr & FILE_ATTRIBUTE_DIRECTORY)) {
		::AfxMessageBox(IDS_PATHNOTFOUND);
		GotoDlgCtrl(GetDlgItem(IDC_FILEEDIT));
		return;
	}

	CNameDialog dlg;
	if (dlg.DoModal() == IDOK) {
#ifndef _EXPLICIT_LOAD_
		short nID = ::AsagiriAddFile(m_hAsagiri, m_nPopupSDK, dlg.m_szName, strPathName);
#else
		short nID = m_pAsagiri->AddFile(m_nPopupSDK, dlg.m_szName, strPathName);
#endif
		if (nID < 0) {
			::AfxMessageBox(IDS_FAILEDITEMADD);
		}
	}
}

//[UC[W{^܂B
void CSampAppDlg::OnBnClickedImagebutton()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	if (m_menuEngine.ShowPopupMenu(ASAITEMTYPE_BITMAPALL, GetDlgItem(IDC_IMAGEBUTTON)) == FALSE) {
		::AfxMessageBox(IDS_NOCORRESPDATA);
	}
}

//[UC[Wi[{^܂B
void CSampAppDlg::OnBnClickedImageupbutton()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	if (m_nPopupSDK < 1) {
		m_nPopupSDK = 0;
		::AfxMessageBox(IDS_CREATEPOPUPSDKFIRST);
		return;
	}

	if (m_hBmp != NULL) {
		CNameDialog dlg;
		if (dlg.DoModal() == IDOK) {
#ifndef _EXPLICIT_LOAD_
			short nID = ::AsagiriAddBitmap(m_hAsagiri, m_nPopupSDK, dlg.m_szName,m_hBmp);
#else
			short nID = m_pAsagiri->AddBitmap(m_nPopupSDK, dlg.m_szName,m_hBmp);
#endif
			if (nID < 0) {
				::AfxMessageBox(IDS_FAILEDITEMADD);
			}
		}
	}
	else {
		::AfxMessageBox(IDS_GETIMAGE);
	}
}

//[UeLXg{^܂B
void CSampAppDlg::OnBnClickedTextbutton()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	if (m_menuEngine.ShowPopupMenu(ASAITEMTYPE_STRINGALL, GetDlgItem(IDC_TEXTBUTTON)) == FALSE) {
		::AfxMessageBox(IDS_NOCORRESPDATA);
	}
}

//[UeLXgi[{^܂B
void CSampAppDlg::OnBnClickedTextupbutton()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	if (m_nPopupSDK < 1) {
		m_nPopupSDK = 0;
		::AfxMessageBox(IDS_CREATEPOPUPSDKFIRST);
		return;
	}

	CString str;
	GetDlgItem(IDC_TEXTEDIT)->GetWindowText(str);
	if (str.IsEmpty() == FALSE) {
		CNameDialog dlg;
		if (dlg.DoModal() == IDOK) {
#ifndef _EXPLICIT_LOAD_
			short nID = ::AsagiriAddText(m_hAsagiri, m_nPopupSDK, dlg.m_szName, str);
#else
			short nID = m_pAsagiri->AddText(m_nPopupSDK, dlg.m_szName, str);
#endif
			if (nID < 0) {
				::AfxMessageBox(IDS_FAILEDITEMADD);
			}
		}
	}
	else {
		::AfxMessageBox(IDS_WRITETEXT);
	}
}

//ACeI܂B
void CSampAppDlg::OnAsaItemCommand(UINT nID)
{
	short nType = 0;
	LPTSTR lpszText = NULL;
	HBITMAP hBmp = NULL;
	LPBYTE lpBinary = NULL;
	DWORD dwSize = NULL;
	nID -= ASAITEMID_MIN;
	LPTSTR lpszServerPath = NULL;
	if (m_menuEngine.GetAsagiriItemData(nID, &nType,
		&lpszText, &hBmp, &lpBinary, &dwSize, &lpszServerPath) == FALSE) {
		if ((nType == ASATYPE_STRINGFILE) ||
			(nType == ASATYPE_BITMAPFILE) ||
			(nType == ASATYPE_BINARYFILE)) {
#ifndef _EXPLICIT_LOAD_
			if (::AsagiriGetFileName(m_hAsagiri, nID, &lpszServerPath) != FALSE) {
#else
			if (m_pAsagiri->GetFileName(nID, &lpszServerPath) != FALSE) {
#endif
				GetDlgItem(IDC_SERVERPATHEDIT)->SetWindowText(lpszServerPath);
			}
			if (lpszServerPath != NULL) {
#ifndef _EXPLICIT_LOAD_
				::AsagiriDeleteString(m_hAsagiri, lpszServerPath);
#else
				m_pAsagiri->DeleteString(lpszServerPath);
#endif
			}
		}
		::AfxMessageBox(IDS_FAILEDGETDATA);
	}
	else {
		switch (nType) {
			case ASATYPE_STRING:
			case ASATYPE_STRINGFILE:
				GetDlgItem(IDC_TEXTEDIT)->SetWindowText(lpszText);
#ifndef _EXPLICIT_LOAD_
				::AsagiriDeleteString(m_hAsagiri, lpszText);
#else
				m_pAsagiri->DeleteString(lpszText);
#endif
				break;
			case ASATYPE_BITMAP:
			case ASATYPE_BITMAPFILE:
				if (m_hBmp != NULL) {
					::DeleteObject((HGDIOBJ) m_hBmp);
				}
				m_hBmp = hBmp;
				((CStatic*) GetDlgItem(IDC_IMAGESTATIC))->SetBitmap(m_hBmp);
				// ̃rbg}bvnh͂ō폜Kv͂܂
				break;
			case ASATYPE_BINARY:
			case ASATYPE_BINARYFILE:
				HexDump(lpBinary, dwSize);
#ifndef _EXPLICIT_LOAD_
				::AsagiriDeleteBinary(m_hAsagiri, lpBinary);
#else
				m_pAsagiri->DeleteBinary(lpBinary);
#endif
				break;
			default:
				break;
		}
		if (lpszServerPath != NULL) {
#ifndef _EXPLICIT_LOAD_
			::AsagiriDeleteString(m_hAsagiri, lpszServerPath);
#else
			m_pAsagiri->DeleteString(lpszServerPath);
#endif
			lpszServerPath = NULL;
			// {͂łɃt@CĂ邪̂߂ɍēx
#ifndef _EXPLICIT_LOAD_
			if (::AsagiriGetFileName(m_hAsagiri, nID, &lpszServerPath) != FALSE) {
#else
			if (m_pAsagiri->GetFileName(nID, &lpszServerPath) != FALSE) {
#endif
				GetDlgItem(IDC_SERVERPATHEDIT)->SetWindowText(lpszServerPath);
			}
		}
		else {
			GetDlgItem(IDC_SERVERPATHEDIT)->SetWindowText(NULL);
		}
		if (lpszServerPath != NULL) {
			if (nType == ASATYPE_BITMAPFILE) {
				int nRet = ::AfxMessageBox(IDS_WRITEIMAGEFILE, MB_YESNO | MB_ICONQUESTION);
				if (nRet == IDYES) {
					WriteImageFile(nID, lpszServerPath);
				}
			}
#ifndef _EXPLICIT_LOAD_
			::AsagiriDeleteString(m_hAsagiri, lpszServerPath);
#else
			m_pAsagiri->DeleteString(lpszServerPath);
#endif
		}
	}
}

// HEX_v\p֐
void CSampAppDlg::HexDump(LPBYTE pBinary, DWORD dwSize)
{
	GetDlgItem(IDC_TEXTEDIT)->SetWindowText(NULL);

	LPBYTE pTemp;
	TCHAR cChar[16];
	DWORD i, dwTextLen, dwLine0, dwLine1, dwSampleLen;
	dwLine0 = dwSize / 16;
	dwLine1 = dwSize % 16;
	dwSampleLen = (DWORD) ::lstrlen(BINARY_SAMPLE);
	dwTextLen = dwLine0 * dwSampleLen;
	dwTextLen += (dwLine1 > 0 ? 1 : 0) * dwSampleLen;
	pTemp = pBinary;
	LPTSTR lpszText = new TCHAR[dwTextLen + 1];

	if (lpszText != NULL) {
		DWORD j, nLine;
		LPTSTR lpszTemp = lpszText;
		nLine = 0;
		for (i = 0; i < dwLine0; i++) {
			for (j = 0; j < 16; j++) {
				cChar[j] = (TCHAR) pTemp[j];
				if (::_istprint(cChar[j]) == 0) {
					cChar[j] = (TCHAR) _T('.');	// ASCII.
				}
				else if (cChar[j] == _T('\t')) {
					cChar[j] = (TCHAR) _T('.');	// ASCII.
				}
			}
			::wsprintf(lpszTemp, BINARY_TEMPLATE, i,
				pTemp[0], pTemp[1], pTemp[2], pTemp[3], pTemp[4], pTemp[5], pTemp[6], pTemp[7],
				pTemp[8], pTemp[9], pTemp[10], pTemp[11], pTemp[12], pTemp[13], pTemp[14], pTemp[15],
				cChar[0], cChar[1], cChar[2], cChar[3], cChar[4], cChar[5], cChar[6], cChar[7],
				cChar[8], cChar[9], cChar[10], cChar[11], cChar[12], cChar[13], cChar[14], cChar[15]);
			pTemp += 16;
			lpszTemp += dwSampleLen;
		}
		nLine = i;
		if (dwLine1 > 0) {
			BYTE bt[16];
			for (i = 0; i < dwLine1; i++) {
				bt[i] = *pTemp;
				pTemp++;
			}
			for (i = dwLine1; i < 16; i++) {
				bt[i] = 0;
			}
			for (j = 0; j < 16; j++) {
				cChar[j] = (TCHAR) bt[j];
				if (::_istprint(cChar[j]) == 0) {
					cChar[j] = (TCHAR) '.';	// ASCII.
				}
				else if (cChar[j] == _T('\t')) {
					cChar[j] = (TCHAR) _T('.');	// ASCII.
				}
			}
			::wsprintf(lpszTemp, BINARY_TEMPLATE, nLine,
				bt[0], bt[1], bt[2], bt[3], bt[4], bt[5], bt[6], bt[7],
				bt[8], bt[9], bt[10], bt[11], bt[12], bt[13], bt[14], bt[15],
				cChar[0], cChar[1], cChar[2], cChar[3], cChar[4], cChar[5], cChar[6], cChar[7],
				cChar[8], cChar[9], cChar[10], cChar[11], cChar[12], cChar[13], cChar[14], cChar[15]);
			// Xy[X𖄂߂
			LPTSTR lpszTemp2 = lpszTemp;
			lpszTemp2 += (dwLine1 * 3);
			for (i = dwLine1; i < 8; i++) {
				lpszTemp2[0] = _T(' ');
				lpszTemp2[1] = _T(' ');
				lpszTemp2 += 3;
			}
			lpszTemp2 = lpszTemp + ::lstrlen(LEAD_FOR8);
			if (dwLine1 > 8) {
				lpszTemp2 += ((dwLine1 - 8) * 3);
			}
			for (i = max(8, dwLine1); i < 16; i++) {
				lpszTemp2[0] = _T(' ');
				lpszTemp2[1] = _T(' ');
				lpszTemp2 += 3;
			}
			lpszTemp2 = lpszTemp + ::lstrlen(LEAD_FORLAST);
			lpszTemp2 += dwLine1;
			*lpszTemp2 = NULL;
		}
		else {
			lpszText[::lstrlen(lpszText) - 1] = 0;
		}
		GetDlgItem(IDC_TEXTEDIT)->SetWindowText(lpszText);
		delete[] lpszText;
	}
}

// C[Wt@Co߂̊֐
void CSampAppDlg::WriteImageFile(short nID, LPCTSTR lpszPathName)
{
	LPBYTE lpContents = NULL;
	DWORD dwSize = 0;
#ifndef _EXPLICIT_LOAD_
	if (::AsagiriGetImageFileInBinary(m_hAsagiri, nID, &lpContents, &dwSize, NULL) != FALSE) {
#else
	if (m_pAsagiri->GetImageFileInBinary(nID, &lpContents, &dwSize, NULL) != FALSE) {
#endif
		LPTSTR lpsz = ::_tcsrchr(lpszPathName, _T('\\'));
		if (lpsz != NULL) {
			lpsz++;
			CFileDialog dlg(FALSE, NULL, lpsz);
			if (dlg.DoModal() == IDOK) {
				CFile file;
				if (file.Open(dlg.GetPathName(), CFile::modeCreate | CFile::modeWrite) != FALSE) {
					file.Write(lpContents, (UINT) dwSize);
					file.Close();
				}
				else {
					::AfxMessageBox(IDS_WRITEIMAGEFILEFAILED);
				}
			}
		}
		else {
			ASSERT(FALSE);
		}
#ifndef _EXPLICIT_LOAD_
		::AsagiriDeleteBinary(m_hAsagiri, lpContents);
#else
		m_pAsagiri->DeleteBinary(lpContents);
#endif
	}
	else {
		::AfxMessageBox(IDS_GETIMAGEFILEFAILED);
	}
}
